* This file is used to print the structures of fields, index, views in a database
* The name of the database with path must be passed on (path could be from current 
* directory f.e. COMMONDB\mydb.dbc where COMMONDB is sub-dir of current directory)

* Though the VFP's own documentation wizard could be used, I was not much impressive
* with that since I burnt my finger once choosing and it corrupted some of my source 
* code. Secondly, it gives too much information which I do not need.

* This program would generate an output file with the name same as database but with
* extention .HTM and place it in the same directory as database.

* I have not spent much error trapping as of now in this program.

* Call syntax => do dbcdoc with "mydb.dbc"

* I am happy if you find this small utility usefull.
* Regards Vijayaraman - vijayaramanl@hotmail.com

LPARAMETERS cDBName
LOCAL i, j, cListFile, cDBShortName, cDBFullName, cTemp, cTemp2

SET EXCLUSIVE OFF
SET DATE BRITISH
cDBName = DefaultExt(cDBName, 'DBC')
IF !File(cDBName)
	MessageBox('No such database exists')
	Return
EndIf
OPEN DATA (cDBName)
cListFile = ADATABASES(aTMP)
IF VarType(aTMP) = "U"
	MessageBox('Database could not be opened')
	Return
EndIF
cDBFullName = aTMP[1,2]
cDBShortName = aTMP[1,1]
cListFile = Left(cDBFullName, Len(cDBFullName)-4)+".HTM"
SET TEXTMERGE TO (cListFile) NOSHOW
SET TEXTMERGE ON

ADBObjects(aDBTable, "Table")
If VarType(aDBTable) <> "U"
	* Sort the array
	ASort(aDBTable)
	\<HTML>
	\<HEAD><TITLE>DATABASE STRUCTURE</TITLE></HEAD>
	\<BODY>
	\<TABLE CELLSPACING=0 BORDER=1 CELLPADDING=1>
		\<TR><TD VALIGN="CENTER">
		\<P ALIGN="LEFT"><B><FONT FACE="Arial" COLOR="#0000ff">TABLES IN DATABASE - <<cDBFullName>></P></B></FONT>
		\</TD></TR>
	\</TABLE>
	\<BR>

	For i = 1 To ALen(aDBTable)
		Wait "Opening table "+aDBTable[i] Window Nowait
		USE (aDBTable[i]) ALIAS cPRNTable
		IF USED('cPRNTable')
			IF AFields(aTblField, 'cPRNTable') <= 0
				USE IN cPRNTable
				LOOP
			ENDIF
			\<U><FONT FACE="Arial">Structure of table</U> : </FONT>
			\<FONT FACE="Arial" COLOR="#ff0000"><B><<aDBTable[i]>></B></FONT>
			\ (Fields: <<ALen(aTblField,1)>>)

			\<TABLE BORDER CELLSPACING=1 CELLPADDING=1 WIDTH=620>
			\<FONT FACE="Arial" SIZE=1>
			\<TR ALIGN="CENTER">
				\<TD VALIGN="CENTER"><B>Field Name</B></TD>
				\<TD VALIGN="CENTER"><B>Type</B></TD>
				\<TD VALIGN="CENTER"><B>Width</B></TD>
				\<TD VALIGN="CENTER"><B>Dec</B></TD>
				\<TD VALIGN="CENTER"><B>Nulls</B></TD>
				\<TD VALIGN="CENTER"><B>Default</B></TD>
			\</TR>
			For j = 1 To ALen(aTblField,1)
				\<TR ALIGN="CENTER">
					\<TD ALIGN="LEFT" VALIGN="CENTER"><<aTblField[j,1]>></TD>
					\<TD VALIGN="CENTER"><<aTblField[j,2]>></TD>
					\<TD VALIGN="CENTER"><<aTblField[j,3]>></TD>
					\<TD VALIGN="CENTER"><<aTblField[j,4]>></TD>
					\<TD VALIGN="CENTER"><<IIF(aTblField[j,5],"Yes","No")>></TD>
					\<TD VALIGN="CENTER"><<IIF(Empty(aTblField[j,9]),"-",aTblField[j,9])>></TD>
				\</TR>
			EndFor
			\</FONT>
			\</TABLE>
			
			\<U><FONT FACE="Arial">Indices in this table</U> : </FONT>
			\
			\<FONT FACE="Arial" SIZE=1>
			\<TABLE BORDER CELLSPACING=1 CELLPADDING=1 WIDTH=620>
			\<TR ALIGN="CENTER">
				\<TD VALIGN="CENTER"><B>Tag Name</B></TD>
				\<TD VALIGN="CENTER"><B>Primary</B></TD>
				\<TD VALIGN="CENTER"><B>Key</B></TD>
			\</TR>
			For j = 1 To TagCount()
				\<TR ALIGN="CENTER">
					\<TD ALIGN="LEFT" VALIGN="CENTER"><<Tag(j)>></TD>
					\<TD VALIGN="CENTER"><<IIF(Primary(j),"Yes","No")>></TD>
					\<TD ALIGN="LEFT" VALIGN="CENTER"><<Key(j)>></TD>
				\</TR>
			EndFor
			\</TABLE>
			\</FONT>
			\<BR><BR>
			USE IN cPRNTable
		ENDIF
	EndFor
EndIf
Release aDBTable

ADBObjects(aDBTable, "View")
If VarType(aDBTable) <> "U"
	* Sort the array
	ASort(aDBTable)
	\<TABLE CELLSPACING=0 BORDER=1 CELLPADDING=1>
		\<TR><TD VALIGN="CENTER">
		\<P ALIGN="LEFT"><B><FONT FACE="Arial" COLOR="#0000ff">VIEWS IN DATABASE - <<cDBFullName>></P></B></FONT>
		\</TD></TR>
	\</TABLE>
	\<BR>

	For i = 1 To ALen(aDBTable)
		Wait "Opening view "+aDBTable[i] Window Nowait
		USE (cDBShortName+"!"+aDBTable[i]) NODATA ALIAS cPRNTable
		IF USED('cPRNTable')
			IF AFields(aTblField, 'cPRNTable') <= 0
				USE IN cPRNTable
				LOOP
			ENDIF

			\<U><FONT FACE="Arial">Structure of view</U> : </FONT>
			\<FONT FACE="Arial" COLOR="#ff0000"><B><<aDBTable[i]>></B></FONT>
			\<FONT FACE="Arial" SIZE=1>
			\ (Fields: <<ALen(aDBTable,1)>>)
			
			\<TABLE BORDER CELLSPACING=1 CELLPADDING=1 WIDTH=620>
				\<FONT SIZE=1>
				\<TR><TD VALIGN="CENTER">
				\View Type: <<IIF(DBGetProp(aDBTable[i], "View", "SourceType")=1,"Local","Remote")>><BR>
				\SQL Statement: <<DBGetProp(aDBTable[i], "View", "SQL")>><BR>
				\FetchSize: <<DBGetProp(aDBTable[i], "View", "FetchSize")>><BR>
				\MaxRecords: <<DBGetProp(aDBTable[i], "View", "MaxRecords")>><BR>
				\SendUpdates: <<IIF(DBGetProp(aDBTable[i], "View", "SendUpdates"),"Yes","No")>><BR>
				\</TD></TR></FONT>
			\</TABLE>
			
			\<TABLE BORDER CELLSPACING=1 CELLPADDING=1 WIDTH=620>
			\<TR ALIGN="CENTER">
				\<TD VALIGN="CENTER"><B>Field Name</B></TD>
				\<TD VALIGN="CENTER"><B>Type</B></TD>
				\<TD VALIGN="CENTER"><B>Default</B></TD>
				\<TD VALIGN="CENTER"><B>Key</B></TD>
				\<TD VALIGN="CENTER"><B>Upd</B></TD>
				\<TD VALIGN="CENTER"><B>Update Name</B></TD>
			\</TR>
			For j = 1 To ALen(aTblField,1)
				cTemp = aDBTable[i]+"."+aTblField[j,1]
				cTemp2 = DBGetProp(cTemp, "Field", "Default")
				\<TR ALIGN="CENTER">
					\<TD ALIGN="LEFT" VALIGN="CENTER"><<aTblField[j,1]>></TD>
					\<TD VALIGN="CENTER"><<DBGetProp(cTemp, "Field", "DataType")>></TD>
					\<TD VALIGN="CENTER"><<IIF(Empty(cTemp2),"-",cTemp2)>></TD>
					\<TD VALIGN="CENTER"><<IIF(DBGetProp(cTemp, "Field", "KeyField"),"Yes","No")>></TD>
					\<TD VALIGN="CENTER"><<IIF(DBGetProp(cTemp, "Field", "Updatable"),"Yes","No")>></TD>
					\<TD VALIGN="CENTER"><<DBGetProp(cTemp, "Field", "UpdateName")>></TD>
				\</TR>
			EndFor
			\</TABLE>
			\</FONT>
			\<BR><BR>
			USE IN cPRNTable
		ENDIF
	EndFor
ENDIF
\</BODY>
\</HTML>
SET TEXTMERGE TO
SET TEXTMERGE OFF
Wait Clear
MessageBox('Done')